// Author: Jean-Philippe Beaudet @ S3R3NITY Technology 
//
// Virtuba crud router
// CRUD
//
// Version : 1.0.0
// Copyrigths S3R3NITY Technologies.
//
//========================================================

// dependencies
var aes256 = require('aes256')
var config = require("./config.js");
var md5 = require('js-md5');
var fs = require('fs')
// globals
var TMP_FILE = config.tmp_file
var PASSPHRASE = config.passphrase

// manage keys
var pubkey, virtuba_pubkey, virtuba_privkey;
fs.readFile('./key.pub', (err, data) => {
	if (err) throw err;
	pubkey =data
});
var virtuba_pubkey ;
fs.readFile('./keys/virtuba.pub', (err, data) => {
	if (err) throw err;
	virtuba_pubkey =data
});
var virtuba_privkey ;
fs.readFile('./keys/virtuba.priv', (err, data) => {
	if (err) throw err;
	virtuba_privkey =data
});

// private encrypting helper method
function encrypt(path, finalpath, callback){
	console.log("encrypt")
	var err =null
	//gpg --batch --passphrase "your_secret_pgpkey_passphrase"  --output=./var/tmp/d41d8cd98f00b204e9800998ecf8427e.gpg -u "virtuba_webserver" -r "philtuba" --encrypt ./var/tmp/d41d8cd98f00b204e9800998ecf8427e.json
	const exec = require('child_process').exec;
	exec('gpg --batch --no-tty --passphrase '+config.passphrase+' --output='+finalpath+' -u virtuba_webserver -r philtuba --encrypt '+path, function(error, stdout, stderr){
	if (error) {
		console.error(`exec error: ${error}`);
		err =error
	}
	console.log(`stdout: ${stdout}`);
	console.log(`stderr: ${stderr}`); 
	});
	callback(err)
	
}
function write(jsonpath, msg, options, callback){
	fs.writeFileSync(jsonpath, JSON.stringify(msg), options)
	callback() 
}

// process the json qith the queu msg method
function process_json(msg, username_hash, callback){
	var options = {
		encoding: "ASCII"
	}
	console.log("encrypt_json_start!!!")
	// copy json to target tmp file
	var jsonpath = TMP_FILE+'/'+username_hash+'.json',
	finalpath = TMP_FILE+'/'+username_hash+'.gpg'
	write(jsonpath, msg, options, function(){
		console.log("encrypt_json_middle")
		console.log(jsonpath+' file is saved ');
		encrypt(jsonpath, finalpath, function(err){
			console.log("encrypt_json_end!!!")
			callback()
		});
	})
}
// command file queue 
var queue = {
	username_hash: null,
	tmpfolder : TMP_FILE,
	actions:{
		create : [],
		read: [],
		update: [],
		destroy: []
	}
}
// Main Module
module.exports = {
	// any text to md5 async
	toHash_async : function(msg, callback){
		md5(msg);
		var hash = md5.create();
		callback(null, hash.hex());
		}, 
	// any text to md5
	toHash : function(msg){
		md5(msg);
		var hash = md5.create();
		return(hash.hex());
		}, 
	// crud function
		// add action in the queue
		add : {
			// create (old[or empty], new)
			create : function(old_name, new_name){
				 queue.actions.create.push([old_name, new_name])
				 //console.log(queue)
				 return queue
			},
			// read (target)
			read : function(target){
				queue.actions.read.push(target)
				return queue
			},
			// update (old, new)
			update : function(old_name, new_name){
				queue.actions.update.push([old_name, new_name])
				return queue
			},
			// delete (target)
			destroy : function(target){
				queue.actions.destroy.push(target)
				return queue
			},
		},
		// remove all actions from the queue 
		refresh : function(callback){
			queue = {
				username_hash: null,
				tmpfolder : TMP_FILE,
				actions:{
					create : [],
					read: [],
					update: [],
					destroy: []
				}
			}
			callback(queue)
		},
	// send command file(map_to_push, callback(err, map, data))
		send : function(username_hash, map_to_push, callback){
			console.log("starting up for "+username_hash)
			// complete json
			queue.username_hash = username_hash
			queue.map = TMP_FILE+'/'+username_hash+'.txt'
			// encrypt json
			process_json(queue, username_hash, function(){
				console.log("finishing up for "+username_hash)
				fs.writeFileSync(TMP_FILE+'/'+username_hash+'.txt', map_to_push)
			})
			this.refresh(function(){
				callback(null)
			})
		}
}
